lkml.org 
[lkml]   [2020]   [Mar]   [4]   [last100]   RSS Feed
Views: [wrap][no wrap]   [headers]  [forward] 
 
Messages in this thread
/
Date
From
SubjectRe: [PATCH v3 4/4] USB: pci-quirks: Add Raspberry Pi 4 quirk
On Mon, Mar 02, 2020 at 04:55:28PM +0100, Nicolas Saenz Julienne wrote:
> On the Raspberry Pi 4, after a PCI reset, VL805's firmware may either be
> loaded directly from an EEPROM or, if not present, by the SoC's
> VideCore. Inform VideCore that VL805 was just reset.
>
> Also, as this creates a dependency between XHCI_PCI and VideoCore's,
> reflect that on the firmware interface Kconfg.
>
> Signed-off-by: Nicolas Saenz Julienne <nsaenzjulienne@suse.de>
>
> ---
>
> Changes since v1:
> - Make RASPBERRYPI_FIRMWARE dependent on this quirk to make sure it
> gets compiled when needed.
>
> drivers/firmware/Kconfig | 1 +
> drivers/usb/host/pci-quirks.c | 18 ++++++++++++++++++
> 2 files changed, 19 insertions(+)
>
> diff --git a/drivers/firmware/Kconfig b/drivers/firmware/Kconfig
> index ea869addc89b..40a468d712a5 100644
> --- a/drivers/firmware/Kconfig
> +++ b/drivers/firmware/Kconfig
> @@ -180,6 +180,7 @@ config ISCSI_IBFT
> config RASPBERRYPI_FIRMWARE
> tristate "Raspberry Pi Firmware Driver"
> depends on BCM2835_MBOX
> + default XHCI_PCI
> help
> This option enables support for communicating with the firmware on the
> Raspberry Pi.
> diff --git a/drivers/usb/host/pci-quirks.c b/drivers/usb/host/pci-quirks.c
> index beb2efa71341..aee2eaa3f0e1 100644
> --- a/drivers/usb/host/pci-quirks.c
> +++ b/drivers/usb/host/pci-quirks.c
> @@ -16,6 +16,9 @@
> #include <linux/export.h>
> #include <linux/acpi.h>
> #include <linux/dmi.h>
> +
> +#include <soc/bcm2835/raspberrypi-firmware.h>
> +
> #include "pci-quirks.h"
> #include "xhci-ext-caps.h"
>
> @@ -1243,11 +1246,26 @@ static void quirk_usb_handoff_xhci(struct pci_dev *pdev)
>
> static void quirk_usb_early_handoff(struct pci_dev *pdev)
> {
> + int ret;
> +
> /* Skip Netlogic mips SoC's internal PCI USB controller.
> * This device does not need/support EHCI/OHCI handoff
> */
> if (pdev->vendor == 0x184e) /* vendor Netlogic */
> return;
> +
> + if (pdev->vendor == PCI_VENDOR_ID_VIA && pdev->device == 0x3483) {
> + ret = rpi_firmware_init_vl805(pdev);
> + if (ret)
> + /*
> + * Firmware might be outdated, or else, something
> + * failed, keep going and hope for the best.
> + */
> + dev_warn(&pdev->dev,
> + "Failed to load VL805's firmware: %d\n",
> + ret);

{} please.

Also, you might want to provide a better warning, something like:
"Failed to load VL805's firmware, will continue to attempt to
work, but bad things might happen, you should fix this..."

or something to give people a chance to know what to do here.

thanks,

greg k-h

\
 
 \ /
  Last update: 2020-03-04 10:06    [W:0.072 / U:1.768 seconds]
©2003-2020 Jasper Spaans|hosted at Digital Ocean and TransIP|Read the blog|Advertise on this site